'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: iChengbo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2021-04-17 22:34:04
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @LastEditors: iChengbo
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @LastEditTime: 2021-04-18 09:49:03
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @FilePath: /react-native-error-helper/src/errorBoundary/useErrorBoundry.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var useErrorBoundary = function useErrorBoundary(CustomeErrorBoundary, onDidCatch) {
    var ErrorBoundary = function (_React$Component) {
        _inherits(ErrorBoundary, _React$Component);

        function ErrorBoundary(props) {
            _classCallCheck(this, ErrorBoundary);

            var _this = _possibleConstructorReturn(this, (ErrorBoundary.__proto__ || Object.getPrototypeOf(ErrorBoundary)).call(this, props));

            _this.state = {
                hasError: false,
                error: null
            };
            return _this;
        }

        _createClass(ErrorBoundary, [{
            key: 'componentDidCatch',
            value: function componentDidCatch(error, errorInfo) {
                onDidCatch && onDidCatch(error, errorInfo);
            }
        }, {
            key: 'render',
            value: function render() {
                var _state = this.state,
                    hasError = _state.hasError,
                    error = _state.error;

                if (hasError) {
                    if (CustomeErrorBoundary && typeof CustomeErrorBoundary === 'function') {
                        return _react2.default.createElement(CustomeErrorBoundary, {
                            error: error
                        });
                    } else {
                        return _react2.default.createElement(Text, null, 'Something went wrong.');
                    }
                }

                return this.props.children;
            }
        }], [{
            key: 'getDerivedStateFromError',
            value: function getDerivedStateFromError(error) {
                return { hasError: true, error: error };
            }
        }]);

        return ErrorBoundary;
    }(_react2.default.Component);

    return { ErrorBoundary: ErrorBoundary };
};