'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var noop = function noop() {};

/**
 * 
 * @param {Function} customHandler 
 * @param {Boolean} allowedInDevMode 
 * @returns 
 */
var setGlobalErrorHandler = exports.setGlobalErrorHandler = function setGlobalErrorHandler() {
    var customHandler = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : noop;
    var allowedInDevMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    if (typeof allowedInDevMode !== 'boolean' || typeof customHandler !== 'function') {
        console.log('setGlobalErrorHandler is called with wrong argument types.. first argument should be callback function and second argument is optional should be a boolean');
        console.log('Not setting the JS handler .. please fix setGlobalErrorHandler call');
        return;
    }
    var allowed = allowedInDevMode ? true : !__DEV__;
    if (allowed) {
        global.ErrorUtils.setGlobalHandler(customHandler);
        var consoleError = console.error;
        console.error = function () {
            var _global$ErrorUtils;

            (_global$ErrorUtils = global.ErrorUtils).reportError.apply(_global$ErrorUtils, arguments);
            consoleError.apply(undefined, arguments);
        };
    } else {
        console.log('Skipping setGlobalErrorHandler: Reason: In DEV mode and allowedInDevMode = false');
    }
};

/**
 * 
 * @returns 
 */
var getGlobalErrorHandler = exports.getGlobalErrorHandler = function getGlobalErrorHandler() {
    return global.ErrorUtils.getGlobalHandler();
};