'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var noop = function noop() {};

/**
 * 
 * @param {Function} customHandler
 * @param {Boolean} allowedInDevMode
 * @returns 
 */
var setPromiseUnCatchHandler = exports.setPromiseUnCatchHandler = function setPromiseUnCatchHandler() {
    var customHandler = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : noop;
    var allowedInDevMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    if (typeof customHandler !== 'function' || typeof allowedInDevMode !== 'boolean') {
        console.log('setPromiseUnCatchHandler is called with wrong argument types.. first argument should be callback function and second argument is optional should be a boolean');
        console.log('Not setting the JS handler .. please fix setPromiseUnCatchHandler call');
        return;
    }
    var allowed = allowedInDevMode ? true : !__DEV__;
    if (allowed) {
        require('promise/setimmediate/rejection-tracking').enable({
            allRejections: true,
            onUnhandled: customHandler,
            onHandled: function onHandled(id) {
                var warning = 'Promise Rejection Handled (id: ' + id + ')\n' + 'This means you can ignore any previous messages of the form ' + ('"Possible Unhandled Promise Rejection (id: ' + id + '):"');
                console.warn(warning);
            }
        });
    } else {
        console.log('Skipping setPromiseUnCatchHandler: Reason: In DEV mode and allowedInDevMode = false');
    }
};